package {
	import com.bit101.components.*;
	import com.widged.medias.BitmapLoadEvent;
	import com.widged.medias.BitmapLoader;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.BlendMode;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;

   [SWF(width="575", height="581", backgroundColor="#FFFFFF", frameRate="20")]
	public class ImageMask extends Sprite
	{
		
		private var imageUrl:String = "assets/breakfast.png";
		private var maskUrl:String = "assets/cutout/duotone.png";
		private var imgW:int = 575;
		private var imgH:int = 431;
		private var blend:String = BlendMode.SCREEN;
		
		private var imageData:BitmapData;
		private var maskData:BitmapData;
		
		public function ImageMask()
		{
			imageData = new BitmapData(imgW, imgH, false, 0xFFFFFF);
			var imageSprite:Sprite = getImageSprite(imageData, "image", imageUrl, onImageLoaded);
			this.addChild(imageSprite);
			
			maskData = new BitmapData(imgW, imgH, false, 0xFFFFFF);
			var maskSprite:Sprite = getImageSprite(maskData, "mask", maskUrl, onMaskLoaded);
			this.addChild(maskSprite);

			imageSprite.mask = maskSprite;
		}
		
		private function getImageSprite(bmpData:BitmapData, uName:String, url:String, callBack:Function ):Sprite
		{
			var s:Sprite = new Sprite();
			var imageBitmap:Bitmap = new Bitmap(bmpData);
			s.name = uName;
			s.cacheAsBitmap = true;
			s.addChild(imageBitmap);
			loadBitmapDataFromUrl(url, callBack);
			return s;
		}

		
	      // avoiding the security sandbox violation that occurs when using the url as source
	      private function loadBitmapDataFromUrl(imageUrl:String, callBack:Function):void
	      {
	         var bmpLoader:BitmapLoader = new BitmapLoader();
	         bmpLoader.addEventListener(BitmapLoadEvent.COMPLETE, callBack); 
	         bmpLoader.load(imageUrl);
	      }

	      private function onImageLoaded(event:BitmapLoadEvent):void
	      {
	           var bd:BitmapData = event.bitmap.bitmapData; 
	           imageData.draw(bd);
	           
	      }

	      private function onMaskLoaded(event:BitmapLoadEvent):void
	      {
	           var bd:BitmapData = event.bitmap.bitmapData; 
	           maskData.draw(bd)
	      }
	      


	}
}
